*******************************************************************************
*  PROGRAM:      SightSnd.prg
*
*  WRITTEN BY:   Borland Late Night Crew
*
*  DATE:         7/20/93
*
*  UPDATED:
*
*  VERSION:      Alpha 
*
*  DESCRIPTION:  This program shows how Bladerunner's window objects defined
*                on database fields are related and change as the record pointer
*                changes.  It also displays Bladerunner's imaging and sound
*                commands.
*                A window is displayed containing a listbox of image names, and
*                the image corresponding to the highlighted listbox prompt.
*                This image is retrieved from a database memo field
*                (pictures->bitmap).  Pressing the Sound button, or double
*                clicking anywhere in the window will play the sound
*                corresponding to the current image.  This sound is a .wav
*                file also stored in a databased memo field (pictures->sound).
*                Selecting the "Exit" menu choice, and then the "Exit" pulldown
*                choice closes the window.
*
*  PARAMETERS:   None
*
*  CALLS:        None
*
*  USAGE:        DO SightSnd
*
*
*
*******************************************************************************

private savearea
savearea = str(workarea())


define font RomanBI        height 35 width 27 type "Roman" Bold Italic
define font Modern          height 18 width 15 type "Modern" Bold
define font CourierBI       height 20 width 20 type "Courier" Bold Italic

use pictures in select()
select pictures

define window pictures from 0,0 to 33,78 of application;
   sizeable moveable ;
   color bg/b

define menu choice exit of pictures prompt "File"
define pulldown exit
define pulldown choice 1 of exit prompt "E&xit"
on menu choice exit of pictures activate pulldown exit
on selection pulldown exit close window pictures

define text title of pictures at 1,19 prompt "Sights and Sounds";
   color gr+/n font RomanBI
define pushbutton sound of pictures at 5,1 prompt "Sound" font Modern
define listbox things of pictures prompt field pictures->name;
   from 12,2 to 25,15

define image picture of pictures memo bitmap from 3,20 to 30,75
on selection window pictures play sound memo pictures->sound
* make this window modal
readmodal("pictures")

* Clean up
use
select &savearea
return



